blob: b139491237a37f29f448eedec2da0cb24cb9dcdb [file] [log] [blame]
Jason Kusumabe998f42015-09-03 15:53:13 -07001#!/bin/bash
2
3# Copyright 2015 The Chromium OS Authors. All rights reserved.
4# Use of this source code is governed by a BSD-style license that can be
5# found in the LICENSE file.
6
7# Script to generate a Brillo update for use by the update engine.
8#
9# usage: brillo_update_payload COMMAND [ARGS]
10# The following commands are supported:
11# generate generate an unsigned payload
12# hash generate a payload or metadata hash
13# sign generate a signed payload
Alex Deymo98e691c2016-02-04 21:05:45 -080014# properties generate a properties file from a payload
Jason Kusumabe998f42015-09-03 15:53:13 -070015#
16# Generate command arguments:
Jason Kusuma9a4cae22015-10-08 18:17:57 -070017# --payload generated unsigned payload output file
18# --source_image if defined, generate a delta payload from the specified
19# image to the target_image
20# --target_image the target image that should be sent to clients
21# --metadata_size_file if defined, generate a file containing the size of the payload
22# metadata in bytes to the specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070023#
24# Hash command arguments:
25# --unsigned_payload the input unsigned payload to generate the hash from
26# --signature_size signature sizes in bytes in the following format:
Alex Deymo89ff9e32015-09-15 19:29:01 -070027# "size1:size2[:...]"
Jason Kusumabe998f42015-09-03 15:53:13 -070028# --payload_hash_file if defined, generate a payload hash and output to the
29# specified file
30# --metadata_hash_file if defined, generate a metadata hash and output to the
31# specified file
32#
33# Sign command arguments:
Alex Deymo89ff9e32015-09-15 19:29:01 -070034# --unsigned_payload the input unsigned payload to insert the signatures
35# --payload the output signed payload
36# --signature_size signature sizes in bytes in the following format:
37# "size1:size2[:...]"
38# --payload_signature_file the payload signature files in the following
39# format:
40# "payload_signature1:payload_signature2[:...]"
41# --metadata_signature_file the metadata signature files in the following
42# format:
43# "metadata_signature1:metadata_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -070044# --metadata_size_file if defined, generate a file containing the size of
45# the signed payload metadata in bytes to the
46# specified file
Jason Kusumabe998f42015-09-03 15:53:13 -070047# Note that the number of signature sizes and payload signatures have to match.
Alex Deymo98e691c2016-02-04 21:05:45 -080048#
49# Properties command arguments:
50# --payload the input signed or unsigned payload
51# --properties_file the output path where to write the properties, or
52# '-' for stdout.
53
Jason Kusumabe998f42015-09-03 15:53:13 -070054
Alex Deymo61e1fa82016-01-19 15:16:34 -080055# Exit codes:
56EX_UNSUPPORTED_DELTA=100
57
Jason Kusumaf514c542015-11-05 18:43:45 -080058warn() {
59 echo "brillo_update_payload: warning: $*" >&2
60}
61
Gilad Arnold957ce122015-10-14 16:02:55 -070062die() {
63 echo "brillo_update_payload: error: $*" >&2
64 exit 1
Jason Kusumabe998f42015-09-03 15:53:13 -070065}
66
Gilad Arnold957ce122015-10-14 16:02:55 -070067# Loads shflags. We first look at the default install location; then look for
68# crosutils (chroot); finally check our own directory (au-generator zipfile).
69load_shflags() {
70 local my_dir="$(dirname "$(readlink -f "$0")")"
71 local path
72 for path in /usr/share/misc {/usr/lib/crosutils,"${my_dir}"}/lib/shflags; do
73 if [[ -r "${path}/shflags" ]]; then
74 . "${path}/shflags" || die "Could not load ${path}/shflags."
75 return
76 fi
77 done
78 die "Could not find shflags."
79}
80
81load_shflags
Jason Kusumabe998f42015-09-03 15:53:13 -070082
Alex Deymoc64ffd52015-09-25 18:10:07 -070083HELP_GENERATE="generate: Generate an unsigned update payload."
84HELP_HASH="hash: Generate the hashes of the unsigned payload and metadata used \
85for signing."
86HELP_SIGN="sign: Insert the signatures into the unsigned payload."
Alex Deymo98e691c2016-02-04 21:05:45 -080087HELP_PROPERTIES="properties: Extract payload properties to a file."
Alex Deymoc64ffd52015-09-25 18:10:07 -070088
89usage() {
90 echo "Supported commands:"
91 echo
92 echo "${HELP_GENERATE}"
93 echo "${HELP_HASH}"
94 echo "${HELP_SIGN}"
Alex Deymo98e691c2016-02-04 21:05:45 -080095 echo "${HELP_PROPERTIES}"
Alex Deymoc64ffd52015-09-25 18:10:07 -070096 echo
97 echo "Use: \"$0 <command> --help\" for more options."
98}
99
100# Check that a command is specified.
Jason Kusumabe998f42015-09-03 15:53:13 -0700101if [[ $# -lt 1 ]]; then
Alex Deymo98e691c2016-02-04 21:05:45 -0800102 echo "Please specify a command [generate|hash|sign|properties]"
Jason Kusumabe998f42015-09-03 15:53:13 -0700103 exit 1
104fi
105
Alex Deymoc64ffd52015-09-25 18:10:07 -0700106# Parse command.
107COMMAND="${1:-}"
108shift
109
110case "${COMMAND}" in
111 generate)
112 FLAGS_HELP="${HELP_GENERATE}"
113 ;;
114
115 hash)
116 FLAGS_HELP="${HELP_HASH}"
117 ;;
118
119 sign)
120 FLAGS_HELP="${HELP_SIGN}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700121 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800122
123 properties)
124 FLAGS_HELP="${HELP_PROPERTIES}"
125 ;;
Jason Kusumabe998f42015-09-03 15:53:13 -0700126 *)
Alex Deymoc64ffd52015-09-25 18:10:07 -0700127 echo "Unrecognized command: \"${COMMAND}\"" >&2
128 usage >&2
Jason Kusumabe998f42015-09-03 15:53:13 -0700129 exit 1
130 ;;
131esac
132
Jason Kusumabe998f42015-09-03 15:53:13 -0700133# Flags
Alex Deymoc64ffd52015-09-25 18:10:07 -0700134FLAGS_HELP="Usage: $0 ${COMMAND} [flags]
135${FLAGS_HELP}"
136
137if [[ "${COMMAND}" == "generate" ]]; then
138 DEFINE_string payload "" \
139 "Path to output the generated unsigned payload file."
140 DEFINE_string target_image "" \
141 "Path to the target image that should be sent to clients."
142 DEFINE_string source_image "" \
143 "Optional: Path to a source image. If specified, this makes a delta update."
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700144 DEFINE_string metadata_size_file "" \
145 "Optional: Path to output metadata size."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700146fi
147if [[ "${COMMAND}" == "hash" || "${COMMAND}" == "sign" ]]; then
148 DEFINE_string unsigned_payload "" "Path to the input unsigned payload."
149 DEFINE_string signature_size "" \
150 "Signature sizes in bytes in the following format: size1:size2[:...]"
151fi
152if [[ "${COMMAND}" == "hash" ]]; then
153 DEFINE_string metadata_hash_file "" \
154 "Optional: Path to output metadata hash file."
155 DEFINE_string payload_hash_file "" \
156 "Optional: Path to output payload hash file."
157fi
158if [[ "${COMMAND}" == "sign" ]]; then
159 DEFINE_string payload "" \
160 "Path to output the generated unsigned payload file."
161 DEFINE_string metadata_signature_file "" \
162 "The metatada signatures in the following format: \
163metadata_signature1:metadata_signature2[:...]"
164 DEFINE_string payload_signature_file "" \
165 "The payload signatures in the following format: \
166payload_signature1:payload_signature2[:...]"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700167 DEFINE_string metadata_size_file "" \
168 "Optional: Path to output metadata size."
Alex Deymoc64ffd52015-09-25 18:10:07 -0700169fi
Alex Deymo98e691c2016-02-04 21:05:45 -0800170if [[ "${COMMAND}" == "properties" ]]; then
171 DEFINE_string payload "" \
172 "Path to the input signed or unsigned payload file."
173 DEFINE_string properties_file "-" \
174 "Path to output the extracted property files. If '-' is passed stdout will \
175be used."
176fi
177
Alex Deymo5fbb1102017-01-12 13:55:52 -0800178DEFINE_string work_dir "${TMPDIR:-/tmp}" "Where to dump temporary files."
Jason Kusumabe998f42015-09-03 15:53:13 -0700179
180# Parse command line flag arguments
181FLAGS "$@" || exit 1
182eval set -- "${FLAGS_ARGV}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700183set -e
Jason Kusumabe998f42015-09-03 15:53:13 -0700184
Alex Deymo5fbb1102017-01-12 13:55:52 -0800185# Override the TMPDIR with the passed work_dir flags, which anyway defaults to
186# ${TMPDIR}.
187TMPDIR="${FLAGS_work_dir}"
188export TMPDIR
189
Alex Deymo89ff9e32015-09-15 19:29:01 -0700190# Associative arrays from partition name to file in the source and target
191# images. The size of the updated area must be the size of the file.
192declare -A SRC_PARTITIONS
193declare -A DST_PARTITIONS
194
Alex Deymo20bdc702016-12-07 21:07:11 -0800195# Associative arrays for the .map files associated with each src/dst partition
196# file in SRC_PARTITIONS and DST_PARTITIONS.
197declare -A SRC_PARTITIONS_MAP
198declare -A DST_PARTITIONS_MAP
199
Sen Jiang788c2d92016-03-09 12:48:40 -0800200# List of partition names in order.
201declare -a PARTITIONS_ORDER
202
Alex Deymo89ff9e32015-09-15 19:29:01 -0700203# A list of temporary files to remove during cleanup.
204CLEANUP_FILES=()
205
Alex Deymo48b502a2015-09-17 19:00:18 -0700206# Global options to force the version of the payload.
207FORCE_MAJOR_VERSION=""
208FORCE_MINOR_VERSION=""
209
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800210# Path to the postinstall config file in target image if exists.
211POSTINSTALL_CONFIG_FILE=""
212
Alex Deymoc97df432015-09-25 17:23:52 -0700213# read_option_int <file.txt> <option_key> [default_value]
214#
215# Reads the unsigned integer value associated with |option_key| in a key=value
216# file |file.txt|. Prints the read value if found and valid, otherwise prints
217# the |default_value|.
218read_option_uint() {
219 local file_txt="$1"
220 local option_key="$2"
221 local default_value="${3:-}"
222 local value
223 if value=$(look "${option_key}=" "${file_txt}" | tail -n 1); then
224 if value=$(echo "${value}" | cut -f 2- -d "=" | grep -E "^[0-9]+$"); then
225 echo "${value}"
226 return
227 fi
228 fi
229 echo "${default_value}"
230}
231
Sen Jiangd0e9a892016-07-22 16:28:07 -0700232# truncate_file <file_path> <file_size>
233#
234# Truncate the given |file_path| to |file_size| using perl.
235# The truncate binary might not be available.
236truncate_file() {
237 local file_path="$1"
238 local file_size="$2"
239 perl -e "open(FILE, \"+<\", \$ARGV[0]); \
240 truncate(FILE, ${file_size}); \
241 close(FILE);" "${file_path}"
242}
243
Alex Deymo89ff9e32015-09-15 19:29:01 -0700244# Create a temporary file in the work_dir with an optional pattern name.
245# Prints the name of the newly created file.
246create_tempfile() {
247 local pattern="${1:-tempfile.XXXXXX}"
248 mktemp --tmpdir="${FLAGS_work_dir}" "${pattern}"
249}
Jason Kusumabe998f42015-09-03 15:53:13 -0700250
251cleanup() {
252 local err=""
Alex Deymo89ff9e32015-09-15 19:29:01 -0700253 rm -f "${CLEANUP_FILES[@]}" || err=1
Jason Kusumabe998f42015-09-03 15:53:13 -0700254
255 # If we are cleaning up after an error, or if we got an error during
256 # cleanup (even if we eventually succeeded) return a non-zero exit
257 # code. This triggers additional logging in most environments that call
258 # this script.
259 if [[ -n "${err}" ]]; then
260 die "Cleanup encountered an error."
261 fi
262}
263
264cleanup_on_error() {
265 trap - INT TERM ERR EXIT
266 cleanup
267 die "Cleanup success after an error."
268}
269
270cleanup_on_exit() {
271 trap - INT TERM ERR EXIT
272 cleanup
273}
274
275trap cleanup_on_error INT TERM ERR
276trap cleanup_on_exit EXIT
277
Alex Deymo48b502a2015-09-17 19:00:18 -0700278
Sen Jiang788c2d92016-03-09 12:48:40 -0800279# extract_image <image> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700280#
281# Detect the format of the |image| file and extract its updatable partitions
282# into new temporary files. Add the list of partition names and its files to the
Sen Jiang788c2d92016-03-09 12:48:40 -0800283# associative array passed in |partitions_array|. If |partitions_order| is
284# passed, set it to list of partition names in order.
Alex Deymo48b502a2015-09-17 19:00:18 -0700285extract_image() {
286 local image="$1"
287
288 # Brillo images are zip files. We detect the 4-byte magic header of the zip
289 # file.
290 local magic=$(head --bytes=4 "${image}" | hexdump -e '1/1 "%.2x"')
291 if [[ "${magic}" == "504b0304" ]]; then
292 echo "Detected .zip file, extracting Brillo image."
293 extract_image_brillo "$@"
294 return
295 fi
296
297 # Chrome OS images are GPT partitioned disks. We should have the cgpt binary
298 # bundled here and we will use it to extract the partitions, so the GPT
299 # headers must be valid.
300 if cgpt show -q -n "${image}" >/dev/null; then
301 echo "Detected GPT image, extracting Chrome OS image."
302 extract_image_cros "$@"
303 return
304 fi
305
306 die "Couldn't detect the image format of ${image}"
307}
308
Sen Jiang788c2d92016-03-09 12:48:40 -0800309# extract_image_cros <image.bin> <partitions_array> [partitions_order]
Alex Deymo89ff9e32015-09-15 19:29:01 -0700310#
Alex Deymo48b502a2015-09-17 19:00:18 -0700311# Extract Chromium OS recovery images into new temporary files.
Alex Deymo89ff9e32015-09-15 19:29:01 -0700312extract_image_cros() {
313 local image="$1"
314 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800315 local partitions_order="${3:-}"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700316
317 local kernel root
318 kernel=$(create_tempfile "kernel.bin.XXXXXX")
319 CLEANUP_FILES+=("${kernel}")
320 root=$(create_tempfile "root.bin.XXXXXX")
321 CLEANUP_FILES+=("${root}")
322
323 cros_generate_update_payload --extract \
324 --image "${image}" \
325 --kern_path "${kernel}" --root_path "${root}" \
326 --work_dir "${FLAGS_work_dir}" --outside_chroot
327
Alex Deymo83f2f702015-10-14 14:49:33 -0700328 # Chrome OS uses major_version 1 payloads for all versions, even if the
329 # updater supports a newer major version.
330 FORCE_MAJOR_VERSION="1"
331
Alex Deymo48b502a2015-09-17 19:00:18 -0700332 # When generating legacy Chrome OS images, we need to use "boot" and "system"
333 # for the partition names to be compatible with updating Brillo devices with
334 # Chrome OS images.
335 eval ${partitions_array}[boot]=\""${kernel}"\"
336 eval ${partitions_array}[system]=\""${root}"\"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700337
Sen Jiang788c2d92016-03-09 12:48:40 -0800338 if [[ -n "${partitions_order}" ]]; then
339 eval "${partitions_order}=( \"system\" \"boot\" )"
340 fi
341
Alex Deymo89ff9e32015-09-15 19:29:01 -0700342 local part varname
Alex Deymo48b502a2015-09-17 19:00:18 -0700343 for part in boot system; do
Alex Deymo89ff9e32015-09-15 19:29:01 -0700344 varname="${partitions_array}[${part}]"
345 printf "md5sum of %s: " "${varname}"
346 md5sum "${!varname}"
347 done
348}
349
Sen Jiang788c2d92016-03-09 12:48:40 -0800350# extract_image_brillo <target_files.zip> <partitions_array> [partitions_order]
Alex Deymo48b502a2015-09-17 19:00:18 -0700351#
352# Extract the A/B updated partitions from a Brillo target_files zip file into
353# new temporary files.
354extract_image_brillo() {
355 local image="$1"
356 local partitions_array="$2"
Sen Jiang788c2d92016-03-09 12:48:40 -0800357 local partitions_order="${3:-}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700358
Alex Deymo48b502a2015-09-17 19:00:18 -0700359 local partitions=( "boot" "system" )
Alex Deymo168b5352015-11-04 13:51:52 -0800360 local ab_partitions_list
361 ab_partitions_list=$(create_tempfile "ab_partitions_list.XXXXXX")
362 CLEANUP_FILES+=("${ab_partitions_list}")
363 if unzip -p "${image}" "META/ab_partitions.txt" >"${ab_partitions_list}"; then
364 if grep -v -E '^[a-zA-Z0-9_-]*$' "${ab_partitions_list}" >&2; then
365 die "Invalid partition names found in the partition list."
366 fi
367 partitions=($(cat "${ab_partitions_list}"))
368 if [[ ${#partitions[@]} -eq 0 ]]; then
369 die "The list of partitions is empty. Can't generate a payload."
370 fi
371 else
372 warn "No ab_partitions.txt found. Using default."
373 fi
374 echo "List of A/B partitions: ${partitions[@]}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700375
Sen Jiang788c2d92016-03-09 12:48:40 -0800376 if [[ -n "${partitions_order}" ]]; then
377 eval "${partitions_order}=(${partitions[@]})"
378 fi
379
Alex Deymo83f2f702015-10-14 14:49:33 -0700380 # All Brillo updaters support major version 2.
381 FORCE_MAJOR_VERSION="2"
382
Alex Deymo48b502a2015-09-17 19:00:18 -0700383 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800384 # Source image
385 local ue_config=$(create_tempfile "ue_config.XXXXXX")
Alex Deymoc97df432015-09-25 17:23:52 -0700386 CLEANUP_FILES+=("${ue_config}")
387 if ! unzip -p "${image}" "META/update_engine_config.txt" \
388 >"${ue_config}"; then
389 warn "No update_engine_config.txt found. Assuming pre-release image, \
390using payload minor version 2"
391 fi
Alex Deymo83f2f702015-10-14 14:49:33 -0700392 # For delta payloads, we use the major and minor version supported by the
393 # old updater.
Alex Deymoc97df432015-09-25 17:23:52 -0700394 FORCE_MINOR_VERSION=$(read_option_uint "${ue_config}" \
395 "PAYLOAD_MINOR_VERSION" 2)
Alex Deymo83f2f702015-10-14 14:49:33 -0700396 FORCE_MAJOR_VERSION=$(read_option_uint "${ue_config}" \
397 "PAYLOAD_MAJOR_VERSION" 2)
Alex Deymo61e1fa82016-01-19 15:16:34 -0800398
399 # Brillo support for deltas started with minor version 3.
400 if [[ "${FORCE_MINOR_VERSION}" -le 2 ]]; then
401 warn "No delta support from minor version ${FORCE_MINOR_VERSION}. \
402Disabling deltas for this source version."
403 exit ${EX_UNSUPPORTED_DELTA}
404 fi
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800405 else
406 # Target image
407 local postinstall_config=$(create_tempfile "postinstall_config.XXXXXX")
408 CLEANUP_FILES+=("${postinstall_config}")
409 if unzip -p "${image}" "META/postinstall_config.txt" \
410 >"${postinstall_config}"; then
411 POSTINSTALL_CONFIG_FILE="${postinstall_config}"
412 fi
Alex Deymo48b502a2015-09-17 19:00:18 -0700413 fi
414
415 local part part_file temp_raw filesize
416 for part in "${partitions[@]}"; do
417 part_file=$(create_tempfile "${part}.img.XXXXXX")
418 CLEANUP_FILES+=("${part_file}")
419 unzip -p "${image}" "IMAGES/${part}.img" >"${part_file}"
420
421 # If the partition is stored as an Android sparse image file, we need to
422 # convert them to a raw image for the update.
423 local magic=$(head --bytes=4 "${part_file}" | hexdump -e '1/1 "%.2x"')
424 if [[ "${magic}" == "3aff26ed" ]]; then
425 temp_raw=$(create_tempfile "${part}.raw.XXXXXX")
426 CLEANUP_FILES+=("${temp_raw}")
427 echo "Converting Android sparse image ${part}.img to RAW."
428 simg2img "${part_file}" "${temp_raw}"
429 # At this point, we can drop the contents of the old part_file file, but
430 # we can't delete the file because it will be deleted in cleanup.
431 true >"${part_file}"
432 part_file="${temp_raw}"
433 fi
434
Alex Deymo20bdc702016-12-07 21:07:11 -0800435 # Extract the .map file (if one is available).
436 part_map_file=$(create_tempfile "${part}.map.XXXXXX")
437 CLEANUP_FILES+=("${part_map_file}")
438 unzip -p "${image}" "IMAGES/${part}.map" >"${part_map_file}" || \
439 part_map_file=""
440
Alex Deymoa479a4d2016-05-11 18:13:49 -0700441 # delta_generator only supports images multiple of 4 KiB. For target images
442 # we pad the data with zeros if needed, but for source images we truncate
443 # down the data since the last block of the old image could be padded on
444 # disk with unknown data.
Alex Deymo48b502a2015-09-17 19:00:18 -0700445 filesize=$(stat -c%s "${part_file}")
446 if [[ $(( filesize % 4096 )) -ne 0 ]]; then
Alex Deymoa479a4d2016-05-11 18:13:49 -0700447 if [[ "${partitions_array}" == "SRC_PARTITIONS" ]]; then
448 echo "Rounding DOWN partition ${part}.img to a multiple of 4 KiB."
449 : $(( filesize = filesize & -4096 ))
Alex Deymo04c23052017-04-12 18:15:30 -0700450 if [[ ${filesize} == 0 ]]; then
451 echo "Source partition ${part}.img is empty after rounding down," \
452 "skipping."
453 continue
454 fi
Alex Deymoa479a4d2016-05-11 18:13:49 -0700455 else
456 echo "Rounding UP partition ${part}.img to a multiple of 4 KiB."
457 : $(( filesize = (filesize + 4095) & -4096 ))
458 fi
Sen Jiangd0e9a892016-07-22 16:28:07 -0700459 truncate_file "${part_file}" "${filesize}"
Alex Deymo48b502a2015-09-17 19:00:18 -0700460 fi
461
462 eval "${partitions_array}[\"${part}\"]=\"${part_file}\""
Alex Deymo20bdc702016-12-07 21:07:11 -0800463 eval "${partitions_array}_MAP[\"${part}\"]=\"${part_map_file}\""
Alex Deymo48b502a2015-09-17 19:00:18 -0700464 echo "Extracted ${partitions_array}[${part}]: ${filesize} bytes"
465 done
466}
467
Jason Kusumabe998f42015-09-03 15:53:13 -0700468validate_generate() {
469 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700470 die "You must specify an output filename with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700471
472 [[ -n "${FLAGS_target_image}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700473 die "You must specify a target image with --target_image FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700474}
475
476cmd_generate() {
Alex Deymo89ff9e32015-09-15 19:29:01 -0700477 local payload_type="delta"
Jason Kusumabe998f42015-09-03 15:53:13 -0700478 if [[ -z "${FLAGS_source_image}" ]]; then
Alex Deymo89ff9e32015-09-15 19:29:01 -0700479 payload_type="full"
Jason Kusumabe998f42015-09-03 15:53:13 -0700480 fi
481
Alex Deymo48b502a2015-09-17 19:00:18 -0700482 echo "Extracting images for ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700483
Sen Jiang788c2d92016-03-09 12:48:40 -0800484 extract_image "${FLAGS_target_image}" DST_PARTITIONS PARTITIONS_ORDER
Alex Deymo89ff9e32015-09-15 19:29:01 -0700485 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo48b502a2015-09-17 19:00:18 -0700486 extract_image "${FLAGS_source_image}" SRC_PARTITIONS
Jason Kusumabe998f42015-09-03 15:53:13 -0700487 fi
488
Alex Deymo48b502a2015-09-17 19:00:18 -0700489 echo "Generating ${payload_type} update."
Alex Deymo168b5352015-11-04 13:51:52 -0800490 # Common payload args:
491 GENERATOR_ARGS=( -out_file="${FLAGS_payload}" )
492
493 local part old_partitions="" new_partitions="" partition_names=""
Alex Deymo20bdc702016-12-07 21:07:11 -0800494 local old_mapfiles="" new_mapfiles=""
Sen Jiang788c2d92016-03-09 12:48:40 -0800495 for part in "${PARTITIONS_ORDER[@]}"; do
Alex Deymo168b5352015-11-04 13:51:52 -0800496 if [[ -n "${partition_names}" ]]; then
497 partition_names+=":"
498 new_partitions+=":"
499 old_partitions+=":"
Alex Deymo20bdc702016-12-07 21:07:11 -0800500 new_mapfiles+=":"
501 old_mapfiles+=":"
Alex Deymo168b5352015-11-04 13:51:52 -0800502 fi
503 partition_names+="${part}"
504 new_partitions+="${DST_PARTITIONS[${part}]}"
505 old_partitions+="${SRC_PARTITIONS[${part}]:-}"
Alex Deymo20bdc702016-12-07 21:07:11 -0800506 new_mapfiles+="${DST_PARTITIONS_MAP[${part}]:-}"
507 old_mapfiles+="${SRC_PARTITIONS_MAP[${part}]:-}"
Alex Deymo168b5352015-11-04 13:51:52 -0800508 done
509
510 # Target image args:
511 GENERATOR_ARGS+=(
512 -partition_names="${partition_names}"
513 -new_partitions="${new_partitions}"
Alex Deymo20bdc702016-12-07 21:07:11 -0800514 -new_mapfiles="${new_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700515 )
516
Alex Deymo89ff9e32015-09-15 19:29:01 -0700517 if [[ "${payload_type}" == "delta" ]]; then
Alex Deymo168b5352015-11-04 13:51:52 -0800518 # Source image args:
Jason Kusumabe998f42015-09-03 15:53:13 -0700519 GENERATOR_ARGS+=(
Alex Deymo168b5352015-11-04 13:51:52 -0800520 -old_partitions="${old_partitions}"
Alex Deymo20bdc702016-12-07 21:07:11 -0800521 -old_mapfiles="${old_mapfiles}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700522 )
Alex Deymo48b502a2015-09-17 19:00:18 -0700523 if [[ -n "${FORCE_MINOR_VERSION}" ]]; then
524 GENERATOR_ARGS+=( --minor_version="${FORCE_MINOR_VERSION}" )
525 fi
526 fi
527
528 if [[ -n "${FORCE_MAJOR_VERSION}" ]]; then
529 GENERATOR_ARGS+=( --major_version="${FORCE_MAJOR_VERSION}" )
Jason Kusumabe998f42015-09-03 15:53:13 -0700530 fi
531
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700532 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
533 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
534 fi
535
Sen Jiang6f7b22c2015-11-12 15:50:39 -0800536 if [[ -n "${POSTINSTALL_CONFIG_FILE}" ]]; then
537 GENERATOR_ARGS+=(
538 --new_postinstall_config_file="${POSTINSTALL_CONFIG_FILE}"
539 )
540 fi
541
Jason Kusumabe998f42015-09-03 15:53:13 -0700542 echo "Running delta_generator with args: ${GENERATOR_ARGS[@]}"
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700543 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700544
Alex Deymo89ff9e32015-09-15 19:29:01 -0700545 echo "Done generating ${payload_type} update."
Jason Kusumabe998f42015-09-03 15:53:13 -0700546}
547
548validate_hash() {
549 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700550 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700551
552 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700553 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700554--unsigned_payload FILENAME"
555
Jason Kusumabe998f42015-09-03 15:53:13 -0700556 [[ -n "${FLAGS_payload_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700557 die "You must specify --payload_hash_file FILENAME"
Jason Kusumaf514c542015-11-05 18:43:45 -0800558
559 [[ -n "${FLAGS_metadata_hash_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700560 die "You must specify --metadata_hash_file FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700561}
562
563cmd_hash() {
Sen Jiangbf1266f2015-10-26 11:29:24 -0700564 "${GENERATOR}" \
565 -in_file="${FLAGS_unsigned_payload}" \
566 -signature_size="${FLAGS_signature_size}" \
567 -out_hash_file="${FLAGS_payload_hash_file}" \
568 -out_metadata_hash_file="${FLAGS_metadata_hash_file}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700569
Jason Kusumabe998f42015-09-03 15:53:13 -0700570 echo "Done generating hash."
571}
572
573validate_sign() {
574 [[ -n "${FLAGS_signature_size}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700575 die "You must specify signature size with --signature_size SIZES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700576
577 [[ -n "${FLAGS_unsigned_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700578 die "You must specify the input unsigned payload with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700579--unsigned_payload FILENAME"
580
581 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700582 die "You must specify the output signed payload with --payload FILENAME"
Jason Kusumabe998f42015-09-03 15:53:13 -0700583
584 [[ -n "${FLAGS_payload_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700585 die "You must specify the payload signature file with \
Jason Kusumabe998f42015-09-03 15:53:13 -0700586--payload_signature_file SIGNATURES"
Alex Deymo89ff9e32015-09-15 19:29:01 -0700587
588 [[ -n "${FLAGS_metadata_signature_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700589 die "You must specify the metadata signature file with \
Alex Deymo89ff9e32015-09-15 19:29:01 -0700590--metadata_signature_file SIGNATURES"
Jason Kusumabe998f42015-09-03 15:53:13 -0700591}
592
593cmd_sign() {
Jason Kusuma9a4cae22015-10-08 18:17:57 -0700594 GENERATOR_ARGS=(
595 -in_file="${FLAGS_unsigned_payload}"
596 -signature_size="${FLAGS_signature_size}"
597 -signature_file="${FLAGS_payload_signature_file}"
598 -metadata_signature_file="${FLAGS_metadata_signature_file}"
599 -out_file="${FLAGS_payload}"
600 )
601
602 if [[ -n "${FLAGS_metadata_size_file}" ]]; then
603 GENERATOR_ARGS+=( --out_metadata_size_file="${FLAGS_metadata_size_file}" )
604 fi
605
606 "${GENERATOR}" "${GENERATOR_ARGS[@]}"
Jason Kusumabe998f42015-09-03 15:53:13 -0700607 echo "Done signing payload."
608}
609
Alex Deymo98e691c2016-02-04 21:05:45 -0800610validate_properties() {
611 [[ -n "${FLAGS_payload}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700612 die "You must specify the payload file with --payload FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800613
614 [[ -n "${FLAGS_properties_file}" ]] ||
Sen Jiang53f04d72016-07-13 16:43:39 -0700615 die "You must specify a non empty --properties_file FILENAME"
Alex Deymo98e691c2016-02-04 21:05:45 -0800616}
617
618cmd_properties() {
619 "${GENERATOR}" \
620 -in_file="${FLAGS_payload}" \
621 -properties_file="${FLAGS_properties_file}"
622}
623
Jason Kusumabe998f42015-09-03 15:53:13 -0700624# Sanity check that the real generator exists:
Sen Jiang13519752016-08-02 16:10:52 -0700625GENERATOR="$(which delta_generator || true)"
Jason Kusumabe998f42015-09-03 15:53:13 -0700626[[ -x "${GENERATOR}" ]] || die "can't find delta_generator"
627
628case "$COMMAND" in
629 generate) validate_generate
630 cmd_generate
631 ;;
632 hash) validate_hash
633 cmd_hash
634 ;;
635 sign) validate_sign
636 cmd_sign
637 ;;
Alex Deymo98e691c2016-02-04 21:05:45 -0800638 properties) validate_properties
639 cmd_properties
640 ;;
Jason Kusumabe998f42015-09-03 15:53:13 -0700641esac